// HV1Object.cpp : Implementation of CHV1Object. It encapsulates a 45 array of doubles
#include "stdafx.h"
#include "HV1.h"
#include "HV1Object.h"
#include <math.h>
#include <iostream.h>


/////////////////////////////////////////////////////////////////////////////
// CHV1Object

int CHV1Object::dimension=45;
int CHV1Object::ninst=0;


CHV1Object::~CHV1Object(){
	if(x)
		delete []x;
}

CHV1Object::CHV1Object(){
	x=NULL;
}


STDMETHODIMP CHV1Object::distance(IMTobject *o, double *d)
{
	*d=0.0;
	int size;
	o->compressedSize(&size);
	byte *buff=new byte[size];
	o->compress(buff,&size);
	double *x1=(double *)buff;
	for(int i=0; i<dimension; i++) *d+=pow(x[i]-x1[i], 2); // L2
	*d=sqrt(*d);
	delete []buff;//L2
	return S_OK;
}

STDMETHODIMP CHV1Object::compress(unsigned char *buff, int *size)
{
	memcpy(buff,x,dimension*sizeof(double));
	*size=dimension*sizeof(double);
	return S_OK;
}

STDMETHODIMP CHV1Object::compressedSize(int *size)
{
	*size=dimension*sizeof(double);
	return S_OK;
}

STDMETHODIMP CHV1Object::initialize(unsigned char *buff)
{
	if(x)
		delete []x;
	x=(double *)new byte[dimension*sizeof(double)];
	memcpy(x,buff,dimension*sizeof(double));
	return S_OK;
}

STDMETHODIMP CHV1Object::equal(IMTobject *obj, int *res){
	int size=dimension*sizeof(double);
	byte *buff=new byte[size];
	obj->compress(buff,&size);
	*res= !memcmp(x,buff,size);
	delete buff;
	return S_OK;
}

STDMETHODIMP CHV1Object::XMLInitialize(CHAR * buff)
{
	return E_NOTIMPL;
}

