// Histo144Object.h : Declaration of the CHisto144Object

#ifndef __HISTO144OBJECT_H_
#define __HISTO144OBJECT_H_

#include <math.h>

#include "resource.h"       // main symbols
#import "D:\users\amato\work\ECHO-trees\SDK-distribution\interfaces\Object.tlb" raw_interfaces_only, raw_native_types, no_namespace, named_guids 

/////////////////////////////////////////////////////////////////////////////
// CHisto144Object
class ATL_NO_VTABLE CHisto144Object : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CHisto144Object, &CLSID_Histo144Object>,
	public IDispatchImpl<IHisto144Object, &IID_IHisto144Object, &LIBID_HISTO144Lib>,
	public IDispatchImpl<IMTobject, &IID_IMTobject, &LIBID_MTOBJECTLib>
{
public:
	CHisto144Object();
	~CHisto144Object();

DECLARE_REGISTRY_RESOURCEID(IDR_HISTO144OBJECT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CHisto144Object)
	COM_INTERFACE_ENTRY(IHisto144Object)
//DEL 	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY2(IDispatch, IHisto144Object)
	COM_INTERFACE_ENTRY(IMTobject)
END_COM_MAP()

// IHisto144Object
public:
// IMTobject
	STDMETHOD(distance)(IMTobject * o, DOUBLE * d)
	{
		*d=0.0;
		int size;
		o->compressedSize(&size);
		byte *buff=new byte[size];
		o->compress(buff,&size);
		double *x1=(double *)buff;
		for(int i=0; i<dimension; i++) *d+=pow(x[i]-x1[i], 2); // L2
		*d=sqrt(*d);
		delete []buff;//L2
		return S_OK;
	}
	STDMETHOD(compress)(BYTE * buff, INT * size)
	{
		memcpy(buff,x,dimension*sizeof(double));
		*size=dimension*sizeof(double);
		return S_OK;
	}
	STDMETHOD(compressedSize)(INT * size)
	{
		*size=dimension*sizeof(double);
		return S_OK;
	}
	STDMETHOD(initialize)(BYTE * buff)
	{
		if(x)
			delete []x;
		x=(double *)new byte[dimension*sizeof(double)];
		memcpy(x,buff,dimension*sizeof(double));
		return S_OK;
	}
	STDMETHOD(equal)(IMTobject * obj, INT * res)
	{
		int size=dimension*sizeof(double);
		byte *buff=new byte[size];
		obj->compress(buff,&size);
		*res= !memcmp(x,buff,size);
		delete buff;
		return S_OK;
	}
	STDMETHOD(XMLInitialize)(CHAR * buff)
	{
		return E_NOTIMPL;
	}
private:
	static int dimension;
	double * x;

};

#endif //__HISTO144OBJECT_H_
